package java.util.logging;

import java.util.ResourceBundle;
import java.text.MessageFormat;
import java.util.MissingResourceException;

public abstract class Formatter
{
    protected Formatter() {
    }
    
    public abstract String format(LogRecord p0);
    
    public String getHead(Handler handler) {
        return "";
    }
    
    public String getTail(Handler handler) {
        return "";
    }
    
    public synchronized String formatMessage(LogRecord logRecord) {
        String pattern = logRecord.getMessage();
        ResourceBundle resourceBundle = logRecord.getResourceBundle();
        if (resourceBundle != null) {
            try {
                pattern = resourceBundle.getString(logRecord.getMessage());
            }
            catch (MissingResourceException ex) {
                pattern = logRecord.getMessage();
            }
        }
        try {
            Object[] parameters = logRecord.getParameters();
            if (parameters == null || parameters.length == 0) {
                return pattern;
            }
            if (pattern.indexOf("{0") >= 0 || pattern.indexOf("{1") >= 0 || pattern.indexOf("{2") >= 0 || pattern.indexOf("{3") >= 0) {
                return MessageFormat.format(pattern, parameters);
            }
            return pattern;
        }
        catch (Exception ex2) {
            return pattern;
        }
    }
}
